freeslot("sfx_step1", "sfx_step2", "sfx_step3", "sfx_step4", "sfx_drop1", "sfx_drop2", "sfx_drop3", "sfx_flhs1", "sfx_flhs2", "sfx_flhs3", "sfx_flhs4", "sfx_flhs5", "sfx_flhs6", "sfx_hitb1", "sfx_hitb2", "sfx_slpt1", "sfx_fear1", "sfx_fear2", "sfx_fear3", "sfx_fear4", "sfx_fear5", "sfx_fear6", "sfx_fear7", "sfx_fear8", "sfx_fear9", "sfx_fear10", "sfx_fear11", "sfx_fear12", "sfx_fear12", "sfx_fear14", "sfx_fear15", "sfx_pain1", "sfx_pain2", "sfx_pain3", "sfx_pain4", "sfx_pain5", "sfx_pain6", "sfx_pain7", "sfx_pain8", "sfx_pain9", "sfx_pain10", "sfx_scrm1", "sfx_scrm2", "sfx_scrm3", "sfx_scrm4", "sfx_scrm5", "sfx_scrm6", "sfx_scrm7", "sfx_scrm8", "sfx_scrm9", "sfx_scrm10", "sfx_scrm11", "sfx_scrm12", "sfx_scrm13", "sfx_scrm14", "sfx_scrm15", "sfx_scrm16", "sfx_scrm17", "sfx_scrm18", "sfx_scrm19", "sfx_scrm20", "sfx_scrm21", "sfx_scrm22", "sfx_scrm23", "sfx_scrm24", "sfx_scrm25")
freeslot("MT_DEADE1", "MT_DEADE2", "MT_DEADE3", "MT_DEADN1", "MT_DEADN2", "MT_DEADN3", "MT_DEADL1", "MT_DEADL2", "MT_DEADL3", "MT_DEADS1", "MT_DEADS2", "MT_DEADS3", "MT_SGIB")
freeslot("S_DEADE1", "S_DEADE2", "S_DEADE3", "S_DEADN1", "S_DEADN2", "S_DEADN3", "S_DEADL1", "S_DEADL2", "S_DEADL3", "S_DEADS1", "S_DEADS2", "S_DEADS3", "S_PLAY_FWAL", "S_PLAY_FRUN", "S_PLAY_CROUCH", "S_PLAY_SLIDE", "S_PLAY_ROLLA", "S_SGIB")
freeslot("SPR_SCIE", "SPR_SCIN", "SPR_SCIL", "SPR_SCIS", "SPR_GIB_", "SPR2_FSTN", "SPR2_FWAL", "SPR2_FRUN", "SPR2_CROU", "SPR2_SLID")

mobjinfo[MT_DEADE1] = {
	spawnstate = S_DEADE1,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADE2] = {
	spawnstate = S_DEADE2,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADE3] = {
	spawnstate = S_DEADE3,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADN1] = {
	spawnstate = S_DEADN1,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADN2] = {
	spawnstate = S_DEADN2,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADN3] = {
	spawnstate = S_DEADN3,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADL1] = {
	spawnstate = S_DEADL1,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADL2] = {
	spawnstate = S_DEADL2,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADL3] = {
	spawnstate = S_DEADL3,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADS1] = {
	spawnstate = S_DEADS1,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADS2] = {
	spawnstate = S_DEADS2,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_DEADS3] = {
	spawnstate = S_DEADS3,
	height = 104*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_SCENERY
}
mobjinfo[MT_SGIB] = {
	spawnstate = S_SGIB,
	height = 32*FRACUNIT,
	radius = 32*FRACUNIT,
	speed = 30,
	mass = 100,
	activesound = sfx_flhs1,
	flags = MF_BOUNCE
}

states[S_PLAY_FWAL] = {
	sprite = SPR_PLAY,
	frame = SPR2_FWAL,
	tics = 2,
	nextstate = S_PLAY_WALK
}

states[S_PLAY_FRUN] = {
	sprite = SPR_PLAY,
	frame = SPR2_FRUN,
	tics = 2,
	nextstate = S_PLAY_RUN
}

function A_rolla(mo, var1)
	mo.player.height = var1
end
function A_crouch(mo, var1)
	mo.player.height = var1
	mo.player.powers[pw_nocontrol] = 32768
end
function A_slide(mo, var1)
	A_crouch(mo, var1)
	if mo.player.speed > 0
		P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUST)
		S_StartSound(mo, sfx_s3k7e)
	end
end

states[S_PLAY_ROLLA] = {
	sprite = SPR_PLAY,
	frame = SPR2_ROLL,
	tics = 1,
	action = A_rolla,
	var1 = 52*FRACUNIT,
	nextstate = S_PLAY_ROLL
}

states[S_PLAY_CROUCH] = {
	sprite = SPR_PLAY,
	frame = SPR2_CROU,
	tics = 5,
	action = A_crouch,
	var1 = 52*FRACUNIT,
	nextstate = S_PLAY_STND
}

states[S_PLAY_SLIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SLID,
	tics = 5,
	action = A_slide,
	var1 = 32*FRACUNIT,	
	nextstate = S_PLAY_CROUCH
}

states[S_SGIB] = {
	sprite = SPR_GIB_,
	tics = 500
}

states[S_DEADE1] = {
	sprite = SPR_SCIE,
	frame = A,
	tics = 1000
}
states[S_DEADE2] = {
	sprite = SPR_SCIE,
	frame = B,
	tics = 1000
}
states[S_DEADE3] = {
	sprite = SPR_SCIE,
	frame = C,
	tics = 1000
}

states[S_DEADN1] = {
	sprite = SPR_SCIN,
	frame = A,
	tics = 1000
}
states[S_DEADN2] = {
	sprite = SPR_SCIN,
	frame = B,
	tics = 1000
}
states[S_DEADN3] = {
	sprite = SPR_SCIN,
	frame = C,
	tics = 1000
}

states[S_DEADL1] = {
	sprite = SPR_SCIL,
	frame = A,
	tics = 1000
}
states[S_DEADL2] = {
	sprite = SPR_SCIL,
	frame = B,
	tics = 1000
}
states[S_DEADL3] = {
	sprite = SPR_SCIL,
	frame = C,
	tics = 1000
}

states[S_DEADS1] = {
	sprite = SPR_SCIS,
	frame = A,
	tics = 1000
}
states[S_DEADS2] = {
	sprite = SPR_SCIS,
	frame = B,
	tics = 1000
}
states[S_DEADS3] = {
	sprite = SPR_SCIS,
	frame = C,
	tics = 1000
}

local steps = {sfx_step1, sfx_step2, sfx_step3, sfx_step4}
local bdrops = {sfx_drop1, sfx_drop2, sfx_drop3}
local fleshes = {sfx_flhs1, sfx_flhs2, sfx_flhs3, sfx_flhs4, sfx_flhs5, sfx_flhs6}
local hits = {sfx_hitb1, sfx_hitb2}
local splat = sfx_slpt1
local fears = {sfx_fear1, sfx_fear2, sfx_fear3, sfx_fear4, sfx_fear5, sfx_fear6, sfx_fear7, sfx_fear8, sfx_fear9, sfx_fear10, sfx_fear11, sfx_fear12, sfx_fear12, sfx_fear14, sfx_fear15}
local pains = {sfx_pain1, sfx_pain2, sfx_pain3, sfx_pain4, sfx_pain5, sfx_pain6, sfx_pain7, sfx_pain8, sfx_pain9, sfx_pain10}
local screams = {sfx_scrm1, sfx_scrm2, sfx_scrm3, sfx_scrm4, sfx_scrm5, sfx_scrm6, sfx_scrm7, sfx_scrm8, sfx_scrm9, sfx_scrm10, sfx_scrm11, sfx_scrm12, sfx_scrm13, sfx_scrm14, sfx_scrm15, sfx_scrm16, sfx_scrm17, sfx_scrm18, sfx_scrm19, sfx_scrm20, sfx_scrm21, sfx_scrm22, sfx_scrm23, sfx_scrm24, sfx_scrm25}

local gibs = {A, B, C, D, F, G, H, I, J, K}
local deadstatese = {MT_DEADE1, MT_DEADE2, MT_DEADE3}
local deadstatesn = {MT_DEADN1, MT_DEADN2, MT_DEADN3}
local deadstatesl = {MT_DEADL1, MT_DEADL2, MT_DEADL3}
local deadstatess = {MT_DEADS1, MT_DEADS2, MT_DEADS3}
local sctPanimInfo = {
	["walkFrames"] = {0,8},
	["runFrames"] = {0,8}
}

local function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

local function resetTimefearSound(player)
	player.fearsoundtime = 60*TICRATE
end

local function resetTimefear(player)
	player.timefear = 300*TICRATE
end

local function playerReset(player)
	player.deadbody = false
	player.deadbodyspw = false
	player.gibs = false
	player.fear = 1
	resetTimefearSound(player)
	resetTimefear(player)
	
	player.valueset = true
end

local function addFear(player)
	player.fear = min(10, player.fear + 1)
	resetTimefear(player)
end

rawset(_G, "P_DeadBody", function(player, deadstate)
	local deadBody = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, deadstate)
	deadBody.skin = player.mo.skin
	deadBody.color = player.skincolor
	deadBody.scale = player.mo.scale
	deadBody.height = player.mo.height
	deadBody.angle = player.mo.angle
	
	return deadBody
end)

rawset(_G, "P_Gib", function(player, frame)
	local gib = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SGIB)
	gib.frame = frame
	gib.scale = gib.scale/2
	gib.info.activesound = fleshes[P_RandomKey(#fleshes)+1]
	
	P_InstaThrust(gib, (P_RandomKey(16)+1)*ANGLE_22h, player.speed+(20*FRACUNIT))
	
	return gib
end)

addHook("PlayerSpawn", function(player)
	if player and player.mo and (player.mo.skin == "scieinstein" or player.mo.skin == "scinerd" or player.mo.skin == "sciluther" or player.mo.skin == "scislick")
		playerReset(player)
	end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.skin == "scieinstein" or target.skin == "scinerd" or target.skin == "sciluther" or target.skin == "scislick"
		local player = target.player
		addFear(player)
	end
end, MT_PLAYER)

addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target.skin == "scieinstein" or target.skin == "scinerd" or target.skin == "sciluther" or target.skin == "scislick"
		local player = target.player
		if damage == DMG_SPIKE or damage == DMG_NUKE or damage == DMG_INSTAKILL or damage == DMG_DEATHPIT or damage == DMG_CRUSHED
			player.gibs = true
			player.playsplash = true
			player.mo.moz = 0
			player.mo.mox = 0
			player.mo.moy = 0
			//Spawn gibs
			P_Gib(player, A)
			P_Gib(player, B)
			P_Gib(player, C)
			P_Gib(player, D)
			P_Gib(player, E)
			P_Gib(player, F)
			P_Gib(player, G)
			P_Gib(player, H)
			P_Gib(player, I)
			P_Gib(player, J)
			P_Gib(player, K)
		else
			player.deadbody = true
		end
	elseif inflictor and (inflictor.skin == "scieinstein" or inflictor.skin == "scinerd" or inflictor.skin == "sciluther" or inflictor.skin == "scislick")
		local player = inflictor.player
		addFear(player)
		
		if player.fearsoundtime == 0
			if player.fear < 10
				S_StartSound(player.mo, fears[P_RandomKey(#fears) + 1])
			else
				S_StartSound(player.mo, screams[P_RandomKey(#screams) + 1])
			end
			resetTimefearSound(player)
		end
	end
end)

addHook("PlayerThink", function(player) 
	if player.mo and (player.mo.skin == "scieinstein" or player.mo.skin == "scinerd" or player.mo.skin == "sciluther" or player.mo.skin == "scislick")
		if not(player.valueset)
			playerReset(player)
		end
		
		//normalspeed fear based
		player.normalspeed = max(20,(20*(player.fear/4)))*FRACUNIT
		
		//Fear cooldown
		if player.fear > 1
			player.timefear = max(0, $1 - TICRATE)
			
			if player.timefear == 0
				player.fear = max(1, $1 - 1)
				resetTimefear(player)
			end
		end
		
		//Fear voice cooldown
		if player.fearsoundtime > 0
			player.fearsoundtime = max(0, $1 - TICRATE)
		end
		
		player.timefear = max(0, $1 - TICRATE)
		
		if player.timefear == 0
			player.fear = max(1, $1 - 1)
			resetTimefear(player)
		end
		
		//Animation Stuff
		if player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_FWAL or player.mo.state == S_PLAY_SLIDE
			if P_IsObjectOnGround(player.mo)
				if player.cmd.buttons & BT_CUSTOM1 and player.speed > 0
					player.mo.state = S_PLAY_SLIDE
				elseif player.mo.state ~= S_PLAY_SLIDE
					player.powers[pw_nocontrol] = 0
					player.height = 104*FRACUNIT
					if player.fear >= 5 and player.speed ~= 0
						player.mo.state = S_PLAY_FWAL
					end
					
					if player.speed >= 10*FRACUNIT
						player.mo.tics = 1
					elseif player.mo.tics > 2
						player.mo.tics = 2
					end				
				end
			else
				player.mo.state = S_PLAY_FALL
			end
		elseif player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_FRUN
			if P_IsObjectOnGround(player.mo)
				if player.cmd.buttons & BT_CUSTOM1 and player.speed > 0
					player.mo.state = S_PLAY_SLIDE
				elseif player.mo.state ~= S_PLAY_SLIDE
					player.powers[pw_nocontrol] = 0
					player.height = 104*FRACUNIT
					if player.fear >= 5 and player.speed >= player.runspeed
						player.mo.state = S_PLAY_FRUN
					else
						player.mo.tics = 1
					end
				end
			else
				player.mo.state = S_PLAY_FALL
			end
		elseif player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING
			player.mo.tics = 1
			if player.cmd.buttons & BT_USE
				player.mo.state = S_PLAY_ROLLA
				S_StartSound(player.mo, sfx_s3k42)
			end
		elseif player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_RIDE
			player.mo.anim_duration = 1
		elseif player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_CROUCH
			if player.cmd.buttons & BT_CUSTOM1
				player.mo.state = S_PLAY_CROUCH
			elseif player.mo.state ~= S_PLAY_CROUCH
				player.powers[pw_nocontrol] = 0
				player.height = 104*FRACUNIT
				if player.fear < 5
					player.mo.sprite2 = SPR2_STND
					player.mo.frame = 0
				elseif player.fear >= 5
					player.mo.sprite2 = SPR2_FSTN
					player.mo.frame = player.mo.frame|FF_ANIMATE
					player.mo.anim_duration = 1
				end
			end
		end
		
		//Death Body|Gibs
		if player.deadbody == true and not(player.deadbodyspw) and P_IsObjectOnGround(player.mo) and player.deadtimer > 5
			if player.mo.skin == "scieinstein"
				P_DeadBody(player, deadstatese[P_RandomKey(#deadstatese) + 1])
			elseif player.mo.skin == "scinerd"
				P_DeadBody(player, deadstatesn[P_RandomKey(#deadstatesn) + 1])
			elseif player.mo.skin == "sciluther"
				P_DeadBody(player, deadstatesl[P_RandomKey(#deadstatesl) + 1])
			elseif player.mo.skin == "scislick"
				P_DeadBody(player, deadstatess[P_RandomKey(#deadstatess) + 1])
			end
			player.deadbodyspw = true
			player.mo.sprite = SPR_NULL
		elseif player.gibs == true
			player.mo.sprite = SPR_NULL
		end
		
		//Steps sounds
		player.playstep = false
		player.playdrop = false
		if P_IsObjectOnGround(player.mo)
			if not(player.wasfalling)
				if not (player.powers[pw_carry])
					if player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_FRUN
						player.playstep = (has_value(sctPanimInfo["runFrames"], player.mo.frame & FF_FRAMEMASK) or has_value(sctPanimInfo["runFrames"], player.mo.frame))
					elseif player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_FWAL
						player.playstep = (has_value(sctPanimInfo["walkFrames"], player.mo.frame & FF_FRAMEMASK) or has_value(sctPanimInfo["walkFrames"], player.mo.frame))
					elseif player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_EDGE
						player.playstep = player.lastanim ~= player.panim
					elseif player.mo.state == S_PLAY_WAIT 
						player.playstep = player.lastanim ~= player.panim
					end

					player.playstep = player.playstep and player.lastframe ~= player.mo.frame and not (player.mo.eflags & MFE_GOOWATER)
				end
			else
				player.wasfalling = false
				if player.mo.state == S_PLAY_DEAD
					player.playdrop = player.deadbody
				else
					player.playstep = true
				end
			end
		else
			player.wasfalling = true
		end	
		
		//Voice sounds
		player.playpain = false
		player.playscream = false
		if player.laststate ~= player.mo.state
			if player.mo.state == S_PLAY_PAIN
				player.playpain = player.fear < 5
				player.playscream = player.fear >= 5
			else 
				player.playscream = player.mo.state == S_PLAY_DEAD and player.deadbody
			end
		end
		
		if player.playpain
			S_StartSound(player.mo, pains[P_RandomKey(#pains) + 1])
			S_StartSound(player.mo, hits[P_RandomKey(#hits) + 1])
		elseif player.playscream
			S_StartSound(player.mo, screams[P_RandomKey(#screams) + 1])
			S_StartSound(player.mo, hits[P_RandomKey(#hits) + 1])
		end
		
		if player.playstep
			S_StartSound(player.mo, steps[P_RandomKey(#steps) + 1])
		end
		
		if player.playdrop
			S_StartSound(player.mo, bdrops[P_RandomKey(#bdrops) + 1])
		end
		
		if player.playsplash
			S_StartSound(player.mo, splat)
			player.playsplash = false
		end
							
		player.laststate = player.mo.state
		player.lastframe = player.mo.frame
		player.lastanim = player.panim
	end
end)